From 739985a09c0df50a6c2bbcb481a129d018c74391 Mon Sep 17 00:00:00 2001
From: Nariman-Sayed <narimansayed28@gmail.com>
Date: Wed, 21 Jan 2026 14:30:25 +0200
Subject: [PATCH] Fix: calculate bit_rate over entire fragmented MP4

---
 libavformat/isom.h |  150 +-
 libavformat/mov.c  | 3757 ++++++++++++++++++++++----------------------
 2 files changed, 1933 insertions(+), 1974 deletions(-)

diff --git a/libavformat/isom.h b/libavformat/isom.h
index 55bc2827b4..b8a0252724 100644
--- a/libavformat/isom.h
+++ b/libavformat/isom.h
@@ -37,7 +37,7 @@
 #include "internal.h"
 #include "dv.h"
 
-/* isom.c */
+ /* isom.c */
 extern const AVCodecTag ff_mp4_obj_type[];
 extern const AVCodecTag ff_codec_movvideo_tags[];
 extern const AVCodecTag ff_codec_movaudio_tags[];
@@ -84,8 +84,8 @@ typedef struct MOVElst {
 
 typedef struct MOVDref {
     uint32_t type;
-    char *path;
-    char *dir;
+    char* path;
+    char* dir;
     char volume[28];
     char filename[64];
     int16_t nlvl_to, nlvl_from;
@@ -127,7 +127,7 @@ typedef struct MOVEncryptionIndex {
     // Individual encrypted samples.  If there are no elements, then the default
     // settings will be used.
     unsigned int nb_encrypted_samples;
-    AVEncryptionInfo **encrypted_samples;
+    AVEncryptionInfo** encrypted_samples;
 
     uint8_t* auxiliary_info_sizes;
     size_t auxiliary_info_sample_count;
@@ -145,7 +145,7 @@ typedef struct MOVFragmentStreamInfo {
     // Index of the first sample/trun in the fragment.
     int index_base;
     int index_entry;
-    MOVEncryptionIndex *encryption_index;
+    MOVEncryptionIndex* encryption_index;
     int stsd_id; // current fragment stsd_id
 } MOVFragmentStreamInfo;
 
@@ -154,7 +154,7 @@ typedef struct MOVFragmentIndexItem {
     int headers_read;
     int current;
     int nb_stream_info;
-    MOVFragmentStreamInfo * stream_info;
+    MOVFragmentStreamInfo* stream_info;
 } MOVFragmentIndexItem;
 
 typedef struct MOVFragmentIndex {
@@ -162,7 +162,7 @@ typedef struct MOVFragmentIndex {
     int complete;
     int current;
     int nb_items;
-    MOVFragmentIndexItem * item;
+    MOVFragmentIndexItem* item;
 } MOVFragmentIndex;
 
 typedef struct MOVIndexRange {
@@ -171,42 +171,45 @@ typedef struct MOVIndexRange {
 } MOVIndexRange;
 
 typedef struct MOVStreamContext {
-    AVIOContext *pb;
+    int64_t fragment_duration_sum;
+    int64_t fragment_size_sum;
+    int64_t total_data_size;
+    AVIOContext* pb;
     int refcount;
     int pb_is_copied;
     int id;               ///< AVStream id
     int ffindex;          ///< AVStream index
     int next_chunk;
     unsigned int chunk_count;
-    int64_t *chunk_offsets;
+    int64_t* chunk_offsets;
     unsigned int tts_count;
     unsigned int tts_allocated_size;
-    MOVTimeToSample *tts_data;
+    MOVTimeToSample* tts_data;
     unsigned int stts_count;
     unsigned int stts_allocated_size;
-    MOVStts *stts_data;
+    MOVStts* stts_data;
     unsigned int sdtp_count;
-    uint8_t *sdtp_data;
+    uint8_t* sdtp_data;
     unsigned int ctts_count;
     unsigned int ctts_allocated_size;
-    MOVCtts *ctts_data;
+    MOVCtts* ctts_data;
     unsigned int stsc_count;
-    MOVStsc *stsc_data;
+    MOVStsc* stsc_data;
     unsigned int stsc_index;
     int stsc_sample;
     unsigned int stps_count;
-    unsigned *stps_data;  ///< partial sync sample for mpeg-2 open gop
-    MOVElst *elst_data;
+    unsigned* stps_data;  ///< partial sync sample for mpeg-2 open gop
+    MOVElst* elst_data;
     unsigned int elst_count;
     int tts_index;
     int tts_sample;
     unsigned int sample_size; ///< may contain value calculated from stsd or value from stsz atom
     unsigned int stsz_sample_size; ///< always contains sample size from stsz atom
     unsigned int sample_count;
-    unsigned int *sample_sizes;
+    unsigned int* sample_sizes;
     int keyframe_absent;
     unsigned int keyframe_count;
-    int *keyframes;
+    int* keyframes;
     int time_scale;
     int64_t time_offset;  ///< time offset of the edit list entries
     int64_t min_corrected_pts;  ///< minimum Composition time shown by the edits excluding empty edits.
@@ -220,7 +223,7 @@ typedef struct MOVStreamContext {
     int pseudo_stream_id; ///< -1 means demux all ids
     int16_t audio_cid;    ///< stsd audio compression id
     unsigned drefs_count;
-    MOVDref *drefs;
+    MOVDref* drefs;
     int dref_id;
     unsigned tref_flags;
     int tref_id;
@@ -238,14 +241,14 @@ typedef struct MOVStreamContext {
     int64_t track_end;    ///< used for dts generation in fragmented movie files
     int start_pad;        ///< amount of samples to skip due to enc-dec delay
     unsigned int rap_group_count;
-    MOVSbgp *rap_group;
+    MOVSbgp* rap_group;
     unsigned int sync_group_count;
-    MOVSbgp *sync_group;
-    uint8_t *sgpd_sync;
+    MOVSbgp* sync_group;
+    uint8_t* sgpd_sync;
     uint32_t sgpd_sync_count;
-    int32_t *sample_offsets;
+    int32_t* sample_offsets;
     int sample_offsets_count;
-    int *open_key_samples;
+    int* open_key_samples;
     int open_key_samples_count;
     uint32_t min_sample_duration;
 
@@ -253,22 +256,22 @@ typedef struct MOVStreamContext {
     int64_t duration_for_fps;
 
     /** extradata array (and size) for multiple stsd */
-    uint8_t **extradata;
-    int *extradata_size;
+    uint8_t** extradata;
+    int* extradata_size;
     int last_stsd_index;
     int stsd_count;
     int stsd_version;
 
-    int32_t *display_matrix;
-    AVStereo3D *stereo3d;
+    int32_t* display_matrix;
+    AVStereo3D* stereo3d;
     size_t stereo3d_size;
-    AVSphericalMapping *spherical;
+    AVSphericalMapping* spherical;
     size_t spherical_size;
-    AVMasteringDisplayMetadata *mastering;
+    AVMasteringDisplayMetadata* mastering;
     size_t mastering_size;
-    AVContentLightMetadata *coll;
+    AVContentLightMetadata* coll;
     size_t coll_size;
-    AVAmbientViewingEnvironment *ambient;
+    AVAmbientViewingEnvironment* ambient;
     size_t ambient_size;
 
     uint32_t format;
@@ -276,26 +279,19 @@ typedef struct MOVStreamContext {
     int has_sidx;  // If there is an sidx entry for this stream.
     struct {
         struct AVAESCTR* aes_ctr;
-        struct AVAES *aes_ctx;
+        struct AVAES* aes_ctx;
         unsigned int per_sample_iv_size;  // Either 0, 8, or 16.
-        AVEncryptionInfo *default_encrypted_sample;
-        MOVEncryptionIndex *encryption_index;
+        AVEncryptionInfo* default_encrypted_sample;
+        MOVEncryptionIndex* encryption_index;
     } cenc;
 
-    struct IAMFDemuxContext *iamf;
+    struct IAMFDemuxContext* iamf;
     int iamf_stream_offset;
 } MOVStreamContext;
 
-typedef struct HEIFItemRef {
-    uint32_t type;
-    int item_id;
-} HEIFItemRef;
-
 typedef struct HEIFItem {
-    AVStream *st;
-    HEIFItemRef *iref_list;
-    int nb_iref_list;
-    char *name;
+    AVStream* st;
+    char* name;
     int item_id;
     int64_t extent_length;
     int64_t extent_offset;
@@ -306,21 +302,21 @@ typedef struct HEIFItem {
     int vflip;
     int type;
     int is_idat_relative;
-    uint8_t *icc_profile;
+    uint8_t* icc_profile;
     size_t icc_profile_size;
 } HEIFItem;
 
 typedef struct HEIFGrid {
-    HEIFItem *item;
-    HEIFItem **tile_item_list;
-    int16_t *tile_id_list;
-    unsigned *tile_idx_list;
+    HEIFItem* item;
+    HEIFItem** tile_item_list;
+    int16_t* tile_id_list;
+    unsigned* tile_idx_list;
     int nb_tiles;
 } HEIFGrid;
 
 typedef struct MOVContext {
-    const AVClass *class; ///< class for private options
-    AVFormatContext *fc;
+    const AVClass* class; ///< class for private options
+    AVFormatContext* fc;
     int time_scale;
     int64_t duration;     ///< duration of the longest track
     int found_moov;       ///< 'moov' atom has been found
@@ -329,17 +325,17 @@ typedef struct MOVContext {
     int found_mdat;       ///< 'mdat' atom has been found
     int found_hdlr_mdta;  ///< 'hdlr' atom with type 'mdta' has been found
     int trak_index;       ///< Index of the current 'trak'
-    char **meta_keys;
+    char** meta_keys;
     unsigned meta_keys_count;
-    DVDemuxContext *dv_demux;
-    AVFormatContext *dv_fctx;
+    DVDemuxContext* dv_demux;
+    AVFormatContext* dv_fctx;
     int isom;             ///< 1 if file is ISO Media (mp4/3gp)
     MOVFragment fragment; ///< current fragment in moof atom
-    MOVTrackExt *trex_data;
+    MOVTrackExt* trex_data;
     unsigned trex_count;
     int itunes_metadata;  ///< metadata are itunes style
     int handbrake_version;
-    int *chapter_tracks;
+    int* chapter_tracks;
     unsigned int nb_chapter_tracks;
     int use_absolute_path;
     int ignore_editlist;
@@ -350,7 +346,7 @@ typedef struct MOVContext {
     int64_t next_root_atom; ///< offset of the next root atom
     int export_all;
     int export_xmp;
-    int *bitrates;          ///< bitrates read before streams creation
+    int* bitrates;          ///< bitrates read before streams creation
     int bitrates_count;
     int moov_retry;
     int use_mfra_for;
@@ -361,16 +357,16 @@ typedef struct MOVContext {
     unsigned int aax_mode;  ///< 'aax' file has been detected
     uint8_t file_key[20];
     uint8_t file_iv[20];
-    void *activation_bytes;
+    void* activation_bytes;
     int activation_bytes_size;
-    void *audible_fixed_key;
+    void* audible_fixed_key;
     int audible_fixed_key_size;
-    void *audible_key;
+    void* audible_key;
     int audible_key_size;
-    void *audible_iv;
+    void* audible_iv;
     int audible_iv_size;
-    struct AVAES *aes_decrypt;
-    uint8_t *decryption_key;
+    struct AVAES* aes_decrypt;
+    uint8_t* decryption_key;
     int decryption_key_len;
     int enable_drefs;
     int32_t movie_display_matrix[3][3]; ///< display matrix from mvhd
@@ -379,18 +375,20 @@ typedef struct MOVContext {
     uint32_t max_stts_delta;
     int primary_item_id;
     int cur_item_id;
-    HEIFItem **heif_item;
+    HEIFItem** heif_item;
     int nb_heif_item;
-    HEIFGrid *heif_grid;
+    HEIFGrid* heif_grid;
     int nb_heif_grid;
+    int* thmb_item_id;
+    int nb_thmb_item;
     int64_t idat_offset;
     int interleaved_read;
 } MOVContext;
 
-int ff_mp4_read_descr_len(AVIOContext *pb);
-int ff_mp4_read_descr(void *logctx, AVIOContext *pb, int *tag);
-int ff_mp4_read_dec_config_descr(void *logctx, AVStream *st, AVIOContext *pb);
-void ff_mp4_parse_es_descr(AVIOContext *pb, int *es_id);
+int ff_mp4_read_descr_len(AVIOContext* pb);
+int ff_mp4_read_descr(void* logctx, AVIOContext* pb, int* tag);
+int ff_mp4_read_dec_config_descr(void* logctx, AVStream* st, AVIOContext* pb);
+void ff_mp4_parse_es_descr(AVIOContext* pb, int* es_id);
 
 #define MP4ODescrTag                    0x01
 #define MP4IODescrTag                   0x02
@@ -452,10 +450,10 @@ void ff_mp4_parse_es_descr(AVIOContext *pb, int *es_id);
      (tag) == MKTAG('A', 'V', 'i', 'n'))
 
 
-int ff_mov_read_esds(AVFormatContext *fc, AVIOContext *pb);
+int ff_mov_read_esds(AVFormatContext* fc, AVIOContext* pb);
 
-int ff_mov_read_stsd_entries(MOVContext *c, AVIOContext *pb, int entries);
-void ff_mov_write_chan(AVIOContext *pb, int64_t channel_layout);
+int ff_mov_read_stsd_entries(MOVContext* c, AVIOContext* pb, int entries);
+void ff_mov_write_chan(AVIOContext* pb, int64_t channel_layout);
 
 #define FF_MOV_FLAG_MFRA_AUTO -1
 #define FF_MOV_FLAG_MFRA_DTS 1
@@ -482,12 +480,12 @@ static inline enum AVCodecID ff_mov_get_lpcm_codec_id(int bps, int flags)
 
 struct MP4TrackKindValueMapping {
     int         disposition;
-    const char *value;
+    const char* value;
 };
 
 struct MP4TrackKindMapping {
-    const char   *scheme_uri;
-    const struct  MP4TrackKindValueMapping *value_maps;
+    const char* scheme_uri;
+    const struct  MP4TrackKindValueMapping* value_maps;
 };
 
 extern const struct MP4TrackKindMapping ff_mov_track_kind_table[];
